Index: uspace/lib/c/generic/cfg.c
===================================================================
--- uspace/lib/c/generic/cfg.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
+++ uspace/lib/c/generic/cfg.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -0,0 +1,447 @@
+/*
+ * Copyright (c) 2011 Radim Vansa
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/**
+ * @addtogroup libc
+ * @{
+ */
+/** @file cfg.c
+ * @brief Configuration files manipulation implementation.
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <str.h>
+#include <errno.h>
+#include <assert.h>
+#include <dirent.h>
+#include <fcntl.h>
+#include <sys/stat.h>
+#include <ctype.h>
+#include <cfg.h>
+
+/**
+ * @param data Configuration file data
+ *
+ * @return Anonymous section in the configuration file.
+ * @return NULL if there is no such section (it is empty)
+ *
+ */
+const cfg_section_t *cfg_anonymous(const cfg_file_t *data)
+{
+	assert(data != NULL);
+	
+	if (list_empty(&data->sections))
+		return NULL;
+	
+	link_t *link = list_first(&data->sections);
+	const cfg_section_t *section = cfg_section_instance(link);
+	if (section->title[0] != 0)
+		return NULL;
+	
+	return section;
+}
+
+/**
+ * @param data Configuration file data
+ *
+ * @return True if the file contains no data
+ *         (no sections, neither anonymous).
+ * @return False otherwise.
+ *
+ */
+bool cfg_empty(const cfg_file_t *data)
+{
+	assert(data != NULL);
+	
+	if (list_empty(&data->sections))
+		return true;
+	
+	list_foreach(data->sections, link) {
+		const cfg_section_t *section = cfg_section_instance(link);
+		
+		if (!list_empty(&section->entries))
+			return false;
+	}
+	
+	return true;
+}
+
+/** Read file contents into memory.
+ *
+ * @param path Path to the file
+ * @param buf  Pointer to pointer to buffer where
+ *             the file contents will be stored
+ *
+ * @return EOK if the file was successfully loaded.
+ * @return ENOMEM if there was not enough memory to load the file
+ * @return EIO if there was a problem with reading the file
+ * @return Other error code if there was a problem openening the file
+ *
+ */
+static int cfg_read(const char *path, char **buf)
+{
+	assert(buf != NULL);
+	
+	int fd = open(path, O_RDONLY);
+	if (fd < 0)
+		return fd;
+	
+	size_t len = lseek(fd, 0, SEEK_END);
+	lseek(fd, 0, SEEK_SET);
+	
+	*buf = malloc(len + 1);
+	if (*buf == NULL) {
+		close(fd);
+		return ENOMEM;
+	}
+	
+	ssize_t rd = read_all(fd, *buf, len);
+	if (rd < 0) {
+		free(*buf);
+		close(fd);
+		return EIO;
+	}
+	
+	(*buf)[len] = 0;
+	close(fd);
+	
+	return EOK;
+}
+
+static inline void null_back(char *back)
+{
+	do {
+		*back = 0;
+		back--;
+	} while (isspace(*back));
+}
+
+/** Allocate and initialize a new entry.
+ *
+ * @param key   Entry key
+ * @param value Entry value
+ *
+ * @return New entry
+ * @return NULL if there was not enough memory
+ *
+ */
+static cfg_entry_t *cfg_new_entry(const char *key, const char *value)
+{
+	cfg_entry_t *entry = malloc(sizeof(cfg_entry_t));
+	if (entry == NULL)
+		return NULL;
+	
+	link_initialize(&entry->link);
+	entry->key = key;
+	entry->value = value;
+	
+	return entry;
+}
+
+/** Allocate and initialize a new section.
+ *
+ * @param title Section title
+ *
+ * @return New section
+ * @return NULL if there was not enough memory
+ *
+ */
+static cfg_section_t *cfg_new_section(const char *title)
+{
+	cfg_section_t *sec = malloc(sizeof(cfg_section_t));
+	if (sec == NULL)
+		return NULL;
+	
+	link_initialize(&sec->link);
+	
+	if (title != NULL)
+		sec->title = title;
+	else
+		sec->title = "";
+	
+	list_initialize(&sec->entries);
+	sec->entry_count = 0;
+	
+	return sec;
+}
+
+/** Skip whitespaces
+ *
+ */
+static inline void skip_whitespaces(char **buffer)
+{
+	while (isspace(**buffer))
+		(*buffer)++;
+}
+
+static inline int starts_comment(char c)
+{
+	return ((c == ';') || (c == '#'));
+}
+
+/** Load file content into memory
+ *
+ * Parse the file into sections and entries
+ * and initialize data with this info.
+ *
+ * @param path Path to the configuration file
+ * @param data Configuration file data
+ *
+ * @return EOK if the file was successfully loaded
+ * @return EBADF if the configuration file has bad format.
+ * @return ENOMEM if there was not enough memory
+ * @return Error code from cfg_read()
+ *
+ */
+int cfg_load(const char *path, cfg_file_t *data)
+{
+	char *buffer;
+	int res = cfg_read(path, &buffer);
+	if (res != EOK)
+		return res;
+	
+	list_initialize(&data->sections);
+	data->section_count = 0;
+	data->data = buffer;
+	
+	cfg_section_t *curr_section = NULL;
+	skip_whitespaces(&buffer);
+	
+	while (*buffer) {
+		while (starts_comment(*buffer)) {
+			while ((*buffer) && (*buffer != '\n'))
+				buffer++;
+			
+			skip_whitespaces(&buffer);
+		}
+		
+		if (*buffer == '[') {
+			buffer++;
+			skip_whitespaces(&buffer);
+			
+			const char *title = buffer;
+			while ((*buffer) && (*buffer != ']') && (*buffer != '\n'))
+				buffer++;
+			
+			if (*buffer != ']') {
+				cfg_unload(data);
+				return EBADF;
+			}
+			
+			null_back(buffer);
+			buffer++;
+			
+			cfg_section_t *sec = cfg_new_section(title);
+			if (sec == NULL) {
+				cfg_unload(data);
+				return ENOMEM;
+			}
+			
+			list_append(&sec->link, &data->sections);
+			data->section_count++;
+			curr_section = sec;
+		} else if (*buffer) {
+			const char *key = buffer;
+			while ((*buffer) && (*buffer != '=') && (*buffer != '\n'))
+				buffer++;
+			
+			if (*buffer != '=') {
+				cfg_unload(data);
+				return EBADF;
+			}
+			
+			/* null = and whitespaces before */
+			null_back(buffer);
+			buffer++;
+			skip_whitespaces(&buffer);
+			
+			while (starts_comment(*buffer)) {
+				while ((*buffer) && (*buffer != '\n'))
+					buffer++;
+				
+				skip_whitespaces(&buffer);
+			}
+			
+			const char *value = buffer;
+			/* Empty value is correct value */
+			if (*buffer) {
+				while ((*buffer) && (*buffer != '\n'))
+					buffer++;
+				
+				if (*buffer) {
+					null_back(buffer);
+					buffer++;
+				} else
+					null_back(buffer);
+			}
+			
+			/* Create anonymous section if not present */
+			if (curr_section == NULL) {
+				curr_section = cfg_new_section(NULL);
+				if (curr_section == NULL) {
+					cfg_unload(data);
+					return ENOMEM;
+				}
+				
+				list_append(&curr_section->link, &data->sections);
+			}
+			
+			cfg_entry_t *entry = cfg_new_entry(key, value);
+			if (entry == NULL) {
+				cfg_unload(data);
+				return ENOMEM;
+			}
+			
+			list_append(&entry->link, &curr_section->entries);
+			curr_section->entry_count++;
+		}
+		
+		skip_whitespaces(&buffer);
+	}
+	
+	return EOK;
+}
+
+/** Load file content into memory (with path)
+ *
+ * Parse the file (with path) into sections and entries
+ * and initialize data with this info.
+ *
+ */
+int cfg_load_path(const char *path, const char *fname, cfg_file_t *data)
+{
+	size_t sz = str_size(path) + str_size(fname) + 2;
+	char *name = malloc(sz);
+	if (name == NULL)
+		return ENOMEM;
+	
+	snprintf(name, sz, "%s/%s", path, fname);
+	int rc = cfg_load(name, data);
+	
+	free(name);
+	
+	return rc;
+}
+
+/** Deallocate memory used by entry
+ *
+ */
+static void cfg_free_entry(const cfg_entry_t *entry)
+{
+	assert(entry != NULL);
+	free(entry);
+}
+
+/** Deallocate memory used by all entries
+ *
+ * Deallocate memory used by all entries within a section
+ * and the memory used by the section itself.
+ *
+ */
+static void cfg_free_section(const cfg_section_t *section)
+{
+	assert(section != NULL);
+	
+	link_t *cur;
+	link_t *next;
+	
+	for (cur = section->entries.head.next;
+	    cur != &section->entries.head;
+	    cur = next) {
+		next = cur->next;
+		cfg_free_entry(cfg_entry_instance(cur));
+	}
+	
+	free(section);
+}
+
+/** Deallocate memory used by configuration data
+ *
+ * Deallocate all inner sections and entries.
+ *
+ */
+void cfg_unload(cfg_file_t *data)
+{
+	assert(data != NULL);
+	
+	link_t *cur, *next;
+	for (cur = data->sections.head.next;
+	    cur != &data->sections.head;
+	    cur = next) {
+		next = cur->next;
+		cfg_free_section(cfg_section_instance(cur));
+	}
+	
+	free(data->data);
+}
+
+/** Find a section in the configuration data
+ *
+ * @param data  Configuration data
+ * @param title Title of the section to search for
+ *
+ * @return Found section
+ * @return NULL if there is no section with such title
+ *
+ */
+const cfg_section_t *cfg_find_section(const cfg_file_t *data, const char *title)
+{
+	list_foreach(data->sections, link) {
+		const cfg_section_t *section = cfg_section_instance(link);
+		
+		if (str_cmp(section->title, title) == 0)
+			return section;
+	}
+	
+	return NULL;
+}
+
+/** Find entry value in the configuration data
+ *
+ * @param section Section in which to search
+ * @param key     Key of the entry we to search for
+ *
+ * @return Value of the entry
+ * @return NULL if there is no entry with such key
+ *
+ */
+const char *cfg_find_value(const cfg_section_t *section, const char *key)
+{
+	list_foreach(section->entries, link) {
+		const cfg_entry_t *entry = cfg_entry_instance(link);
+		
+		if (str_cmp(entry->key, key) == 0)
+			return entry->value;
+	}
+	
+	return NULL;
+}
+
+/** @}
+ */
Index: uspace/lib/c/generic/io/io.c
===================================================================
--- uspace/lib/c/generic/io/io.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/c/generic/io/io.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -418,13 +418,11 @@
 
 	bytes_used = stream->buf_head - stream->buf_tail;
-	if (bytes_used == 0)
-		return;
 
 	/* If buffer has prefetched read data, we need to seek back. */
-	if (stream->buf_state == _bs_read)
+	if (bytes_used > 0 && stream->buf_state == _bs_read)
 		lseek(stream->fd, - (ssize_t) bytes_used, SEEK_CUR);
 
 	/* If buffer has unwritten data, we need to write them out. */
-	if (stream->buf_state == _bs_write)
+	if (bytes_used > 0 && stream->buf_state == _bs_write)
 		(void) _fwrite(stream->buf_tail, 1, bytes_used, stream);
 
Index: uspace/lib/c/generic/ns.c
===================================================================
--- uspace/lib/c/generic/ns.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/c/generic/ns.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -52,7 +52,12 @@
 {
 	async_exch_t *exch = async_exchange_begin(session_ns);
+	if (!exch)
+		return NULL;
 	async_sess_t *sess =
 	    async_connect_me_to(mgmt, exch, service, arg2, arg3);
 	async_exchange_end(exch);
+
+	if (!sess)
+		return NULL;
 	
 	/*
Index: uspace/lib/c/include/adt/list.h
===================================================================
--- uspace/lib/c/include/adt/list.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/c/include/adt/list.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -173,5 +173,5 @@
  *
  */
-static inline int list_empty(list_t *list)
+static inline int list_empty(const list_t *list)
 {
 	return (list->head.next == &list->head);
@@ -186,5 +186,5 @@
  *
  */
-static inline link_t *list_first(list_t *list)
+static inline link_t *list_first(const list_t *list)
 {
 	return ((list->head.next == &list->head) ? NULL : list->head.next);
Index: uspace/lib/c/include/as.h
===================================================================
--- uspace/lib/c/include/as.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/c/include/as.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -60,5 +60,5 @@
 extern void *set_maxheapsize(size_t);
 extern void *as_get_mappable_page(size_t);
-extern int as_get_physical_mapping(void *, uintptr_t *);
+extern int as_get_physical_mapping(const void *, uintptr_t *);
 
 #endif
Index: uspace/lib/c/include/cfg.h
===================================================================
--- uspace/lib/c/include/cfg.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
+++ uspace/lib/c/include/cfg.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -0,0 +1,104 @@
+/*
+ * Copyright (c) 2011 Radim Vansa
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/**
+ * @addtogroup libc
+ * @{
+ */
+/**
+ * @file cfg.h
+ * @brief Simple interface for configuration files manipulation.
+ */
+
+#ifndef LIBC_CFG_H_
+#define LIBC_CFG_H_
+
+#include <adt/list.h>
+#include <sys/types.h>
+#include <bool.h>
+
+/**
+ * One key-value pair
+ */
+typedef struct {
+	link_t link;
+	
+	const char *key;
+	const char *value;
+} cfg_entry_t;
+
+/**
+ * One section in the configuration file.
+ * Has own title (or is anonymous) and contains entries.
+ */
+typedef struct {
+	link_t link;
+	
+	const char *title;
+	list_t entries;
+	size_t entry_count;
+} cfg_section_t;
+
+/**
+ * The configuration file data. The whole file is loaded
+ * into memory and strings in sections (titles) or entries
+ * (keys and values) are only pointers to this memory.
+ * Therefore all the text data are allocated and deallocated
+ * only once, if you want to use the strings after unloading
+ * the configuration file, you have to copy them.
+ */
+typedef struct {
+	list_t sections;
+	size_t section_count;
+	const char *data;
+} cfg_file_t;
+
+#define cfg_file_foreach(file, cur) \
+	list_foreach((file)->sections, (cur))
+
+#define cfg_section_instance(cur) \
+	list_get_instance((cur), const cfg_section_t, link)
+
+#define cfg_section_foreach(section, cur) \
+	list_foreach((section)->entries, (cur))
+
+#define cfg_entry_instance(cur) \
+	list_get_instance((cur), const cfg_entry_t, link)
+
+extern int cfg_load(const char *, cfg_file_t *);
+extern int cfg_load_path(const char *, const char *, cfg_file_t *);
+extern void cfg_unload(cfg_file_t *);
+extern bool cfg_empty(const cfg_file_t *);
+extern const cfg_section_t *cfg_find_section(const cfg_file_t *, const char *);
+extern const char *cfg_find_value(const cfg_section_t *, const char *);
+extern const cfg_section_t *cfg_anonymous(const cfg_file_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/ipc/loc.h
===================================================================
--- uspace/lib/c/include/ipc/loc.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/c/include/ipc/loc.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -97,2 +97,5 @@
 
 #endif
+
+/** @}
+ */
Index: uspace/lib/drv/generic/dev_iface.c
===================================================================
--- uspace/lib/drv/generic/dev_iface.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/drv/generic/dev_iface.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -46,6 +46,4 @@
 #include "remote_pci.h"
 
-#include <stdio.h>
-
 static iface_dipatch_table_t remote_ifaces = {
 	.ifaces = {
@@ -68,8 +66,7 @@
 get_remote_method(remote_iface_t *rem_iface, sysarg_t iface_method_idx)
 {
-	if (iface_method_idx >= rem_iface->method_count) {
+	if (iface_method_idx >= rem_iface->method_count)
 		return NULL;
-	}
-
+	
 	return rem_iface->methods[iface_method_idx];
 }
Index: uspace/lib/drv/generic/remote_usbhc.c
===================================================================
--- uspace/lib/drv/generic/remote_usbhc.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/drv/generic/remote_usbhc.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -41,13 +41,5 @@
 
 #define USB_MAX_PAYLOAD_SIZE 1020
-#define HACK_MAX_PACKET_SIZE 8
-#define HACK_MAX_PACKET_SIZE_INTERRUPT_IN 4
-
-static void remote_usbhc_interrupt_out(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
-static void remote_usbhc_interrupt_in(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
-static void remote_usbhc_bulk_out(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
-static void remote_usbhc_bulk_in(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
-static void remote_usbhc_control_write(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
-static void remote_usbhc_control_read(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
+
 static void remote_usbhc_request_address(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
 static void remote_usbhc_bind_address(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
@@ -56,24 +48,20 @@
 static void remote_usbhc_register_endpoint(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
 static void remote_usbhc_unregister_endpoint(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
+static void remote_usbhc_read(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
+static void remote_usbhc_write(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
 //static void remote_usbhc(ddf_fun_t *, void *, ipc_callid_t, ipc_call_t *);
 
 /** Remote USB host controller interface operations. */
-static remote_iface_func_ptr_t remote_usbhc_iface_ops [] = {
-	remote_usbhc_request_address,
-	remote_usbhc_bind_address,
-	remote_usbhc_find_by_address,
-	remote_usbhc_release_address,
-
-	remote_usbhc_interrupt_out,
-	remote_usbhc_interrupt_in,
-
-	remote_usbhc_bulk_out,
-	remote_usbhc_bulk_in,
-
-	remote_usbhc_control_write,
-	remote_usbhc_control_read,
-
-	remote_usbhc_register_endpoint,
-	remote_usbhc_unregister_endpoint
+static remote_iface_func_ptr_t remote_usbhc_iface_ops[] = {
+	[IPC_M_USBHC_REQUEST_ADDRESS] = remote_usbhc_request_address,
+	[IPC_M_USBHC_BIND_ADDRESS] = remote_usbhc_bind_address,
+	[IPC_M_USBHC_GET_HANDLE_BY_ADDRESS] = remote_usbhc_find_by_address,
+	[IPC_M_USBHC_RELEASE_ADDRESS] = remote_usbhc_release_address,
+
+	[IPC_M_USBHC_REGISTER_ENDPOINT] = remote_usbhc_register_endpoint,
+	[IPC_M_USBHC_UNREGISTER_ENDPOINT] = remote_usbhc_unregister_endpoint,
+
+	[IPC_M_USBHC_READ] = remote_usbhc_read,
+	[IPC_M_USBHC_WRITE] = remote_usbhc_write,
 };
 
@@ -90,5 +78,4 @@
 	ipc_callid_t data_caller;
 	void *buffer;
-	void *setup_packet;
 	size_t size;
 } async_transaction_t;
@@ -98,8 +85,4 @@
 	if (trans == NULL) {
 		return;
-	}
-
-	if (trans->setup_packet != NULL) {
-		free(trans->setup_packet);
 	}
 	if (trans->buffer != NULL) {
@@ -120,5 +103,4 @@
 	trans->data_caller = 0;
 	trans->buffer = NULL;
-	trans->setup_packet = NULL;
 	trans->size = 0;
 
@@ -135,5 +117,5 @@
 		return;
 	}
-	
+
 	usb_speed_t speed = DEV_IPC_GET_ARG1(*call);
 
@@ -239,278 +221,4 @@
 	async_transaction_destroy(trans);
 }
-
-/** Process an outgoing transfer (both OUT and SETUP).
- *
- * @param device Target device.
- * @param callid Initiating caller.
- * @param call Initiating call.
- * @param transfer_func Transfer function (might be NULL).
- */
-static void remote_usbhc_out_transfer(ddf_fun_t *fun,
-    ipc_callid_t callid, ipc_call_t *call,
-    usbhc_iface_transfer_out_t transfer_func)
-{
-	if (!transfer_func) {
-		async_answer_0(callid, ENOTSUP);
-		return;
-	}
-
-	usb_target_t target = {
-		.address = DEV_IPC_GET_ARG1(*call),
-		.endpoint = DEV_IPC_GET_ARG2(*call)
-	};
-
-	size_t len = 0;
-	void *buffer = NULL;
-
-	int rc = async_data_write_accept(&buffer, false,
-	    1, USB_MAX_PAYLOAD_SIZE,
-	    0, &len);
-
-	if (rc != EOK) {
-		async_answer_0(callid, rc);
-		return;
-	}
-
-	async_transaction_t *trans = async_transaction_create(callid);
-	if (trans == NULL) {
-		if (buffer != NULL) {
-			free(buffer);
-		}
-		async_answer_0(callid, ENOMEM);
-		return;
-	}
-
-	trans->buffer = buffer;
-	trans->size = len;
-
-	rc = transfer_func(fun, target,
-	    buffer, len,
-	    callback_out, trans);
-
-	if (rc != EOK) {
-		async_answer_0(callid, rc);
-		async_transaction_destroy(trans);
-	}
-}
-
-/** Process an incoming transfer.
- *
- * @param device Target device.
- * @param callid Initiating caller.
- * @param call Initiating call.
- * @param transfer_func Transfer function (might be NULL).
- */
-static void remote_usbhc_in_transfer(ddf_fun_t *fun,
-    ipc_callid_t callid, ipc_call_t *call,
-    usbhc_iface_transfer_in_t transfer_func)
-{
-	if (!transfer_func) {
-		async_answer_0(callid, ENOTSUP);
-		return;
-	}
-
-	usb_target_t target = {
-		.address = DEV_IPC_GET_ARG1(*call),
-		.endpoint = DEV_IPC_GET_ARG2(*call)
-	};
-
-	size_t len;
-	ipc_callid_t data_callid;
-	if (!async_data_read_receive(&data_callid, &len)) {
-		async_answer_0(callid, EPARTY);
-		return;
-	}
-
-	async_transaction_t *trans = async_transaction_create(callid);
-	if (trans == NULL) {
-		async_answer_0(data_callid, ENOMEM);
-		async_answer_0(callid, ENOMEM);
-		return;
-	}
-	trans->data_caller = data_callid;
-	trans->buffer = malloc(len);
-	trans->size = len;
-
-	int rc = transfer_func(fun, target,
-	    trans->buffer, len,
-	    callback_in, trans);
-
-	if (rc != EOK) {
-		async_answer_0(data_callid, rc);
-		async_answer_0(callid, rc);
-		async_transaction_destroy(trans);
-	}
-}
-
-void remote_usbhc_interrupt_out(ddf_fun_t *fun, void *iface,
-    ipc_callid_t callid, ipc_call_t *call)
-{
-	usbhc_iface_t *usb_iface = (usbhc_iface_t *) iface;
-	assert(usb_iface != NULL);
-
-	return remote_usbhc_out_transfer(fun, callid, call,
-	    usb_iface->interrupt_out);
-}
-
-void remote_usbhc_interrupt_in(ddf_fun_t *fun, void *iface,
-    ipc_callid_t callid, ipc_call_t *call)
-{
-	usbhc_iface_t *usb_iface = (usbhc_iface_t *) iface;
-	assert(usb_iface != NULL);
-
-	return remote_usbhc_in_transfer(fun, callid, call,
-	    usb_iface->interrupt_in);
-}
-
-void remote_usbhc_bulk_out(ddf_fun_t *fun, void *iface,
-    ipc_callid_t callid, ipc_call_t *call)
-{
-	usbhc_iface_t *usb_iface = (usbhc_iface_t *) iface;
-	assert(usb_iface != NULL);
-
-	return remote_usbhc_out_transfer(fun, callid, call,
-	    usb_iface->bulk_out);
-}
-
-void remote_usbhc_bulk_in(ddf_fun_t *fun, void *iface,
-    ipc_callid_t callid, ipc_call_t *call)
-{
-	usbhc_iface_t *usb_iface = (usbhc_iface_t *) iface;
-	assert(usb_iface != NULL);
-
-	return remote_usbhc_in_transfer(fun, callid, call,
-	    usb_iface->bulk_in);
-}
-
-void remote_usbhc_control_write(ddf_fun_t *fun, void *iface,
-ipc_callid_t callid, ipc_call_t *call)
-{
-	usbhc_iface_t *usb_iface = (usbhc_iface_t *) iface;
-	assert(usb_iface != NULL);
-
-	if (!usb_iface->control_write) {
-		async_answer_0(callid, ENOTSUP);
-		return;
-	}
-
-	usb_target_t target = {
-		.address = DEV_IPC_GET_ARG1(*call),
-		.endpoint = DEV_IPC_GET_ARG2(*call)
-	};
-	size_t data_buffer_len = DEV_IPC_GET_ARG3(*call);
-
-	int rc;
-
-	void *setup_packet = NULL;
-	void *data_buffer = NULL;
-	size_t setup_packet_len = 0;
-
-	rc = async_data_write_accept(&setup_packet, false,
-	    1, USB_MAX_PAYLOAD_SIZE, 0, &setup_packet_len);
-	if (rc != EOK) {
-		async_answer_0(callid, rc);
-		return;
-	}
-
-	if (data_buffer_len > 0) {
-		rc = async_data_write_accept(&data_buffer, false,
-		    1, USB_MAX_PAYLOAD_SIZE, 0, &data_buffer_len);
-		if (rc != EOK) {
-			async_answer_0(callid, rc);
-			free(setup_packet);
-			return;
-		}
-	}
-
-	async_transaction_t *trans = async_transaction_create(callid);
-	if (trans == NULL) {
-		async_answer_0(callid, ENOMEM);
-		free(setup_packet);
-		free(data_buffer);
-		return;
-	}
-	trans->setup_packet = setup_packet;
-	trans->buffer = data_buffer;
-	trans->size = data_buffer_len;
-
-	rc = usb_iface->control_write(fun, target,
-	    setup_packet, setup_packet_len,
-	    data_buffer, data_buffer_len,
-	    callback_out, trans);
-
-	if (rc != EOK) {
-		async_answer_0(callid, rc);
-		async_transaction_destroy(trans);
-	}
-}
-
-
-void remote_usbhc_control_read(ddf_fun_t *fun, void *iface,
-ipc_callid_t callid, ipc_call_t *call)
-{
-	usbhc_iface_t *usb_iface = (usbhc_iface_t *) iface;
-	assert(usb_iface != NULL);
-
-	if (!usb_iface->control_read) {
-		async_answer_0(callid, ENOTSUP);
-		return;
-	}
-
-	usb_target_t target = {
-		.address = DEV_IPC_GET_ARG1(*call),
-		.endpoint = DEV_IPC_GET_ARG2(*call)
-	};
-
-	int rc;
-
-	void *setup_packet = NULL;
-	size_t setup_packet_len = 0;
-	size_t data_len = 0;
-
-	rc = async_data_write_accept(&setup_packet, false,
-	    1, USB_MAX_PAYLOAD_SIZE, 0, &setup_packet_len);
-	if (rc != EOK) {
-		async_answer_0(callid, rc);
-		return;
-	}
-
-	ipc_callid_t data_callid;
-	if (!async_data_read_receive(&data_callid, &data_len)) {
-		async_answer_0(callid, EPARTY);
-		free(setup_packet);
-		return;
-	}
-
-	async_transaction_t *trans = async_transaction_create(callid);
-	if (trans == NULL) {
-		async_answer_0(data_callid, ENOMEM);
-		async_answer_0(callid, ENOMEM);
-		free(setup_packet);
-		return;
-	}
-	trans->data_caller = data_callid;
-	trans->setup_packet = setup_packet;
-	trans->size = data_len;
-	trans->buffer = malloc(data_len);
-	if (trans->buffer == NULL) {
-		async_answer_0(data_callid, ENOMEM);
-		async_answer_0(callid, ENOMEM);
-		async_transaction_destroy(trans);
-		return;
-	}
-
-	rc = usb_iface->control_read(fun, target,
-	    setup_packet, setup_packet_len,
-	    trans->buffer, trans->size,
-	    callback_in, trans);
-
-	if (rc != EOK) {
-		async_answer_0(data_callid, rc);
-		async_answer_0(callid, rc);
-		async_transaction_destroy(trans);
-	}
-}
-
 
 void remote_usbhc_register_endpoint(ddf_fun_t *fun, void *iface,
@@ -535,6 +243,5 @@
 	type var = (type) DEV_IPC_GET_ARG##arg_no(*call) % (1 << 8)
 
-	_INIT_FROM_HIGH_DATA2(usb_address_t, address, 1);
-	_INIT_FROM_LOW_DATA2(usb_endpoint_t, endpoint, 1);
+	const usb_target_t target = { .packed = DEV_IPC_GET_ARG1(*call) };
 
 	_INIT_FROM_HIGH_DATA3(usb_speed_t, speed, 2);
@@ -551,10 +258,9 @@
 #undef _INIT_FROM_LOW_DATA3
 
-	int rc = usb_iface->register_endpoint(fun, address, speed, endpoint,
-	    transfer_type, direction, max_packet_size, interval);
+	int rc = usb_iface->register_endpoint(fun, target.address, speed,
+	    target.endpoint, transfer_type, direction, max_packet_size, interval);
 
 	async_answer_0(callid, rc);
 }
-
 
 void remote_usbhc_unregister_endpoint(ddf_fun_t *fun, void *iface,
@@ -578,4 +284,98 @@
 }
 
+void remote_usbhc_read(
+    ddf_fun_t *fun, void *iface, ipc_callid_t callid, ipc_call_t *call)
+{
+	assert(fun);
+	assert(iface);
+	assert(call);
+
+	const usbhc_iface_t *hc_iface = iface;
+
+	if (!hc_iface->read) {
+		async_answer_0(callid, ENOTSUP);
+		return;
+	}
+
+	const usb_target_t target = { .packed = DEV_IPC_GET_ARG1(*call) };
+	const uint64_t setup =
+	    ((uint64_t)DEV_IPC_GET_ARG2(*call)) |
+	    (((uint64_t)DEV_IPC_GET_ARG3(*call)) << 32);
+
+	async_transaction_t *trans = async_transaction_create(callid);
+	if (trans == NULL) {
+		async_answer_0(callid, ENOMEM);
+		return;
+	}
+
+	if (!async_data_read_receive(&trans->data_caller, &trans->size)) {
+		async_answer_0(callid, EPARTY);
+		return;
+	}
+
+	trans->buffer = malloc(trans->size);
+	if (trans->buffer == NULL) {
+		async_answer_0(trans->data_caller, ENOMEM);
+		async_answer_0(callid, ENOMEM);
+		async_transaction_destroy(trans);
+	}
+
+	const int rc = hc_iface->read(
+	    fun, target, setup, trans->buffer, trans->size, callback_in, trans);
+
+	if (rc != EOK) {
+		async_answer_0(trans->data_caller, rc);
+		async_answer_0(callid, rc);
+		async_transaction_destroy(trans);
+	}
+}
+
+void remote_usbhc_write(
+    ddf_fun_t *fun, void *iface, ipc_callid_t callid, ipc_call_t *call)
+{
+	assert(fun);
+	assert(iface);
+	assert(call);
+
+	const usbhc_iface_t *hc_iface = iface;
+
+	if (!hc_iface->write) {
+		async_answer_0(callid, ENOTSUP);
+		return;
+	}
+
+	const usb_target_t target = { .packed = DEV_IPC_GET_ARG1(*call) };
+	const size_t data_buffer_len = DEV_IPC_GET_ARG2(*call);
+	const uint64_t setup =
+	    ((uint64_t)DEV_IPC_GET_ARG3(*call)) |
+	    (((uint64_t)DEV_IPC_GET_ARG4(*call)) << 32);
+
+	async_transaction_t *trans = async_transaction_create(callid);
+	if (trans == NULL) {
+		async_answer_0(callid, ENOMEM);
+		return;
+	}
+
+	if (data_buffer_len > 0) {
+		int rc = async_data_write_accept(&trans->buffer, false,
+		    1, USB_MAX_PAYLOAD_SIZE,
+		    0, &trans->size);
+
+		if (rc != EOK) {
+			async_answer_0(callid, rc);
+			async_transaction_destroy(trans);
+			return;
+		}
+	}
+
+	int rc = hc_iface->write(
+	    fun, target, setup, trans->buffer, trans->size, callback_out, trans);
+
+	if (rc != EOK) {
+		async_answer_0(callid, rc);
+		async_transaction_destroy(trans);
+	}
+}
+
 
 /**
